#!/usr/local/bin/perl --        # -*-Perl-*-          file:  attr-sgmls.pl
#
# Last edited: Wed May 18 21:05:57 1994 by lenst@astrid (Lennart   Staflin)
#
# $Id: attr-sgmls.pl,v 1.1 1994/05/19 21:38:43 lenst Exp lenst $
#

# Attribute value access functions 

#         Value takes one of the following forms:
#
#         IMPLIED
#              The value of the attribute is implied.

sub attr_is_implied {
    local ($_) = @_;
    return $_ eq "" || /^IMPLIED/;
}

#         CDATA data
#              The attribute is character data.  This is used for
#              attributes whose declared value is CDATA.

sub attr_is_cdata {
    local ($_) = @_;
    return /^CDATA/;
}

#         NOTATION nname
#              The attribute is a notation name; nname will  have
#              been  defined using a N command.  This is used for
#              attributes whose declared value is NOTATION.

sub attr_is_notation {
    local ($_) = @_;
    return /^NOTATION/;
}

#         ENTITY name...
#              The attribute is a list of general  entity  names.
#              Each  entity  name will have been defined using an
#
#              I, E or S command.  This is  used  for  attributes
#              whose declared value is ENTITY or ENTITIES.

sub attr_is_entity {
    local ($_) = @_;
    return /^ENTITY/;
}

#         TOKEN token...
#              The attribute is a list of tokens.  This  is  used
#              for  attributes  whose  declared value is anything
#              else.

sub attr_is_token {
    local ($_) = @_;
    return /^TOKEN/;
}

# Return the value of attribute string.
# Return "" if the string is undefined, empty or implied.
sub attr_value {
    local ($_) = @_;
    if (/\w+ /) {
    return $';
    }
    else {
    return "";
    }
}

sub attr_list {
    return split(/ /, &attr_value (@_));
}

1;
