# -*-Perl-*-
# $Id: emulator.pm,v 1.1 2000/04/11 16:38:14 hans Exp $

package emulator;
use Exporter;
@ISA = qw ( Exporter );

sub new {
    my $type = shift;
    my %params = @_;
    my $self = {};
    foreach $key (keys %params) {
	$self->{$key} = $params{$key};
    }
    bless $self;
    return $self;
}

sub display {
    my $self = shift;
    my @keys = @_ ? @_ : sort keys %$self;
    foreach $key (@keys) {
	print "\t$key => $self->{$key}\n";
    }
}

sub objtype {
    return "emulator";
}

#
# Simple attributes
#

sub emulname {
    my $self = shift;
    return $self->{"emulname"};
}

sub addemulyear {
    my $self = shift;
    my ( $emulyear ) = @_;
    $self->{"emulyear"} = $emulyear;
}

sub emulyear {
    my $self = shift;
    return $self->{"emulyear"};
}

sub addemulhome {
    my $self = shift;
    my ( $emulhome ) = @_;
    $self->{"emulhome"} = $emulhome;
}

sub emulhome {
    my $self = shift;
    return $self->{"emulhome"};
}

sub addemuldesc {
    my $self = shift;
    my ( $emuldesc ) = @_;
    $self->{"emuldesc"} = $emuldesc;
}

sub emuldesc {
    my $self = shift;
    return $self->{"emuldesc"};
}


#
# List attributes
#

sub addplays {
    my $self = shift;
    my ( $plays ) = @_;
    push(@{$self->{"plays"}}, $plays);
}

sub plays {
    my $self = shift;
    return @{$self->{"plays"}};
}
