# -*-Perl-*-
# $Id: game.pm,v 1.6 1999/04/30 14:26:14 hans Exp $

package game;
use Exporter;
@ISA = qw ( Exporter );

sub new {
    my $type = shift;
    my %params = @_;
    my $self = {};
    foreach $key (keys %params) {
	$self->{$key} = $params{$key};
    }
    bless $self;
    return $self;
}

sub display {
    my $self = shift;
    my @keys = @_ ? @_ : sort keys %$self;
    foreach $key (@keys) {
	print "\t$key => $self->{$key}\n";
    }
}

sub objtype {
    return "game";
}

#
# Simple attributes
#

sub addgamename {
    my $self = shift;
    my ( $gamename ) = @_;
    $self->{"gamename"} = $gamename;
}

sub gamename {
    my $self = shift;
    return $self->{"gamename"};
}

sub addtype {
    my $self = shift;
    my ( $type ) = @_;
    $self->{"type"} = $type;
}

sub type {
    my $self = shift;
    return $self->{"type"};
}

sub addyear {
    my $self = shift;
    my ( $year ) = @_;
    $self->{"year"} = $year;
}

sub year {
    my $self = shift;
    return $self->{"year"};
}

sub addcomm {
    my $self = shift;
    my ( $comm ) = @_;
    $self->{"comm"} = $comm;
}

sub comm {
    my $self = shift;
    return $self->{"comm"};
}

sub addin {
    my $self = shift;
    my ( $in ) = @_;
    $self->{"in"} = $in;
}

sub in {
    my $self = shift;
    return $self->{"in"};
}

sub addnote {
    my $self = shift;
    my ( $note ) = @_;
    $self->{"note"} = $note;
}

sub note {
    my $self = shift;
    return $self->{"note"};
}

sub addblurb {
    my $self = shift;
    my ( $blurb ) = @_;
    $self->{"blurb"} = $blurb;
}

sub blurb {
    my $self = shift;
    return $self->{"blurb"};
}

sub addreview {
    my $self = shift;
    my ( $review ) = @_;
    $self->{"review"} = $review;
}

sub review {
    my $self = shift;
    return $self->{"review"};
}

sub adddownload {
    my $self = shift;
    my ( $download ) = @_;
    $self->{"download"} = $download;
}

sub download {
    my $self = shift;
    return $self->{"download"};
}

sub company {
    my $self = shift;
    return $self->{"company"};
}

sub addcover {
    my $self = shift;
    my ( $cover ) = @_;
    $self->{"cover"} = $cover;
}

sub cover {
    my $self = shift;
    return $self->{"cover"};
}

sub addpage {
    my $self = shift;
    my ( $page, $pagename ) = @_;
    $self->{"page"} = $page . "" . $pagename;
}

sub page {
    my $self = shift;
    return $self->{"page"};
}

sub addserfile {
    my $self = shift;
    my ( $serfile ) = @_;
    $self->{"serfile"} = $serfile;
}

sub serfile {
    my $self = shift;
    return $self->{"serfile"};
}


#
# List attributes
#

sub addby {
    my $self = shift;
    my ( $by ) = @_;
    push(@{$self->{"by"}}, $by);
}

sub by {
    my $self = shift;
    return @{$self->{"by"}};
}

sub addfor {
    my $self = shift;
    my ( $for ) = @_;
    push(@{$self->{"for"}}, $for);
}

sub for {
    my $self = shift;
    return @{$self->{"for"}};
}

sub addsee {
    my $self = shift;
    my ( $see ) = @_;
    push(@{$self->{"see"}}, main::company::compnametolink($see));
}

sub see {
    my $self = shift;
    return @{$self->{"see"}};
}
